/*
 * machdep.h
 *
 * Created by Ashwin N.
 */

#ifndef _MACHDEP_H_
#define _MACHDEP_H_

#include <stdio.h>

/* for example */
/* typedef FILE md_file_t; */
typedef struct
{
  int start;    /* start position in sram */
  int position; /* current position in sram */
  int size;     /* size of data in sram - initially 0*/
  int max_size; /* max file size */
  char mode[4]; /* mode 'r', 'w', etc */
} md_file_t;

void md_init(void);

void md_slurp(void);

void md_control_keyboard(int mode);

void md_heed_signals(void);

void md_ignore_signals(void);

int md_get_file_id(char *fname);

int md_link_count(char *fname);

void md_gct(struct rogue_time *rt_buf);

void md_gfmt(char *fname, struct rogue_time *rt_buf);

boolean md_df(char *fname);

char * md_gln(void);

void md_sleep(int nsecs);

char * md_malloc(int n);

int md_gseed(void);

void md_exit(int status);

/* file wrappers - generally just wrap f* function */
md_file_t * md_fopen(const char * name, const char * mode);
size_t md_fread(void *ptr, size_t size, size_t nmemb, md_file_t *stream);
size_t md_fwrite(const void *ptr, size_t size, size_t nmemb, md_file_t *stream);
void md_rewind(md_file_t * stream);
int md_fclose(md_file_t * stream);

#endif	/* _MACHDEP_H_ */
